// CIntChoiceDlg - Class for set of variants query dialog, with data querying
// Declaration file
/////////////////////////////////////////////////////////////////////////////

class CIntChoiceDlg: public CDlg
{
public:
	// Constructor for dialog, querying parameters value. Parameters:
	// +) pParent - pointer to a possible parent window for a propting
	//    window;
	// +) x,y - possible coordinates of prompting window relative to parent;
	// +) pPar - pointer to the parameter;
	CIntChoiceDlg(CWnd* pParent, long x, long y, Parameter* pPar):CDlg(pParent,x,y) {m_pPar=pPar;};

	// Constructor for dialog, querying values for data storage. Parameters:
	// +) pParent - pointer to a possible parent window for a propting
	//    window;
	// +) x,y - possible coordinates of prompting window relative to parent;
	// +) vals - an array of pointers to memory, where to store a results;
	// +) cap - string representation of coordinates of the cell, which
	//    contents is edited;
	// +) min, max - acceptable range of values
	// +) options - |-separated list of possible choices
	CIntChoiceDlg(CWnd* pParent, long x, long y, int** vals, UINT count, STRING cap, int min=INT_MIN, int max=INT_MAX, String options = ""):CDlg(pParent,x,y) {m_pVal=vals; m_uiCount=count; strcpy(m_sStr,cap); m_bParam=false; m_iMin=min; m_iMax=max; m_sOptions = options;};

	// Destructor
	virtual ~CIntChoiceDlg() {if (!m_bParam && m_uiCount) delete m_pVal;};

protected:
	// Data-storage members:
	String m_sOptions;
	Parameter* m_pPar;
	int** m_pVal;
	UINT m_uiCount;
	CHAR m_sStr[_MAX_PATH];
	int m_iMax;
	int m_iMin;

public:
	// In this function you have to place parameter value in the dialog
	virtual void PrePrompt();
	// In this function you have to read parameter value entered by user. If
	// the value was changed correctly, it must return true and false
	// otherwise
	virtual void OnOK();
};