// CACrtsIntWW2DDatum - Integer data storage for cartesian metrix
// Declaration file
/////////////////////////////////////////////////////////////////////////////

#define WW_CELL_BACK 0
#define WW_CELL_WIRE 1
#define WW_CELL_TAIL 2
#define WW_CELL_HEAD 3


// This is data class definition
class CACrtsIntWW2DDatum:public CABasicCrts2DDatum<int, CIntChoiceDlg, IDD_CHOICE>
{
public:
	// Class constructor (used most of all to set up the parameters)
	CACrtsIntWW2DDatum();

	// Class destructor
	virtual ~CACrtsIntWW2DDatum();

	// Overloading member functions from CAComponent
	COMPONENT_NAME(Integers for Cartesians 2D (WireWorld))
	COMPONENT_INFO(2D 4-state data storage for cartesian metrics for WireWorld rules set)
	COMPONENT_ICON(IDI_ICON)
	COMPONENT_REQUIRES(Metrics.2D.cartesian.*)
	COMPONENT_REALIZES(Data.int)

	// Overloading member functions from CADatum
	virtual inline COLORREF GetCellColor(CACell c);
	virtual void Set(CACell c,int value);
	virtual bool Query(CWnd* pParent, long x, long y, CACell c, bool selected);
	virtual bool Load(IOStream* st);
	virtual inline void SetDefValue(CACell c) {Set(c,p_cInitial.Get());};

// Parameters:
public:
	ParamInt p_iMin;
	ParamInt p_iMax;
	ParamColor* p_col[4];
	ParamChoice p_cInitial;

// Parameter routines:
public:
	// Sets parameters count
	PARAMETERS_COUNT(8)

	// Sets parameters interface
	BEGIN_PARAMETERS
		PARAMETER(0,&p_igWidth)
		PARAMETER(1,&p_igHeight)
		PARAMETER(2,&p_cBoundary)
		PARAMETER(3,p_col[0])
		PARAMETER(4,p_col[1])
		PARAMETER(5,p_col[2])
		PARAMETER(6,p_col[3])
		PARAMETER(7,&p_cInitial)
	END_PARAMETERS
	PARAMETER_CHANGED
};
