// CAWireWorld2DRules - Rules for WireWorld
// Declaration file
/////////////////////////////////////////////////////////////////////////////

#define WW_CELL_BACK 0  // Background cells
#define WW_CELL_WIRE 1  // Wire cells
#define WW_CELL_TAIL 2  // Electron tail cells
#define WW_CELL_HEAD 3  // Electron head cells

// This is rules class definition
class CAWireWorld2DRules:public CARules
{
public:
	// Class constructor (used most of all to set up the parameters)
	CAWireWorld2DRules();

	// Overloading member functions from CAComponent
	COMPONENT_NAME(WireWorld (plain))
	COMPONENT_INFO(WireWorld rules set (plain variant))
	COMPONENT_ICON(IDI_ICON)
	COMPONENT_REQUIRES(Data.int.*&Metrics.2D.*)

	// Overloading member functions from CARules
	virtual bool Initialize();
	virtual bool SubCompute(Zone& z);

// Parameters:
public:
	ParamInt p_iElectrons;

// Parameter routines:
public:
	// No user-defined parameters
	NO_PARAMETERS

	// Sets analyzable parameters count
	APARAMETERS_COUNT(1)

	// Sets analyzable parameters interface
	BEGIN_APARAMETERS
		PARAMETER(0,&p_iElectrons)
	END_APARAMETERS

private:
	int iq; // Temporary variable for p_iElectrons calculation
};
